# Changelog DTS 4138
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/)

Guiding Principles:
see https://keepachangelog.com/en/1.0.0/#how

Possible log types:  
- [Update instructions] for essential requirements, instructions and information about the software update procedure  
- [Added] for new features  
- [Changed] for changes in existing functionality. Improvements should appear under the 'changed' section  
- [Deprecated] for once-stable features removed in upcoming releases  
- [Removed] for now removed in this release  
- [Fixed] for any bug fixes  
- [Security]  in case of vulnerabilities or other security related changes  

## [08050724.010002.050914 / 08072024] 2024-08-02
### Update instructions
**Former version has to be at or above 26102021!**  
See also Bx-800870.11 or higher: chapter 7

### Added

### Changed
- Update ntp to 4.2.8p18
- Update dropbear (SSH) to 2024.85  

### Deprecated

### Removed

### Fixed
- Fix initial timeset from NTP with address as url and slow DNS server or non resolvable url
- Fix recover password from local backup restore without device restart

### Security
- See "Changed" (updates)


## [08130324.010002.050813 / 13032024] 2024-03-20
### Update instructions
**Former version has to be at or above 26102021!**  
See also Bx-800870.11 or higher: chapter 7

### Added

### Changed
- dtsapp: watchdog time increased to delay unintentional reboot with very high network load

### Deprecated

### Removed

### Fixed

### Security
- Detect and block SSH brute force attack
- Disallow TCP timestamps
- Disallow ICMP timestamps (CVE-1999-0524) 
- Warning in menu if default password is active
- Hide password in menu
- Encrypt password in dts4138.conf file. **CAUTION: a new dts4138.conf file can't be used with older firmware** (password will be set to default)
- Build options changed for dropbear (disable Chacha20-Poly1305 and CBC ciphers) to fix CVE-2023-48795  


## [07291123.010002.050812 / 19122023] 2023-12-19
### Update instructions
**Former version has to be at or above 26102021!**  
See also Bx-800870.11 or higher: chapter 7

### Added
- dtsapp: add log of boot reason
- dtsapp: add detection and log of segmentation fault

### Changed
- Update net-snmp to 5.9.4
- Update dts-snmpd to 1.4 (adapt to net-snmp 5.9.4)

### Deprecated

### Removed

### Fixed
- ntpd: close filehandle in case of pending sample from dts refclock
- dts-snmpd: improve handling of alive notification timeout

### Security
- See "Changed" (updates) 


## [07120523.010002.040711 / 29062023] 2023-06-29
### Update instructions
**Former version has to be at or above 26102021!**  
See also Bx-800870.11 or higher: chapter 7

### Added

### Changed
- Update net-snmp to 5.9.3  
- Update dts-snmpd to 1.3 (adapt to net-snmp 5.9.3)
- Update ntp to 4.2.8p17

### Deprecated

### Removed

### Fixed

### Security
- See "Changed" (updates) 


## [07181122.010002.030611 / 28112022] 2022-11-28
### Update instructions
**Former version has to be at or above 26102021!**  
See also Bx-800870.11 or higher: chapter 7

### Added
- Add USB mode (enable/disable USB port)  
- Add GNSS info for GNSS 4500 to MIB  

### Changed
- Update dropbear (SSH) to 2022.83  
- Update net-snmp to 5.9.1  
- Update dts-snmpd to 1.2 (adapt to net-snmp 5.9.1)
- Update ntp to 4.2.8p15

### Deprecated

### Removed

### Fixed
- Fix mail tls  
- Fix restart of network and network services after restore from backup or default config

### Security
- See "Added" (USB mode) and "Changed" (updates)  

## [07051121.010002.020510 / 29032022] 2022-10-06
### Update instructions
**Update 26102021 has to be done first!**  
See also Bx-800870.10 or higher: chapter 7

### Fixed
- Fix: Sync adjust from NTP was very slow -> improved
- Fix: NTP did not reach stratum 16 in any case

## [07251021.010002.020409 / 26102021] 2021-10-21
### Update instructions
**Update 26082020 has to be done first!**  
See also Bx-800870.10 or higher: chapter 7

### Added
- Added SNMP parameter: order contact
- DCF in adapted for Siemens GPS 2000 antenna with
  Siemens GNSS Interface
- GNSS info for GNSS 4500

### Fixed
- Bugfix ntp for poll interval < 3

### Security
- Code signing added: next update requires signed
  firmware image
- Default settings changed (Telnet & FTP off, SNMP V3 only)

## [06130220.010001.020308 / 26082020] 2020-08-31
### Update instructions
Update is recommended for users of SINEC/SIMATIC functionality  
1. step: Update **rootfsDTS4138.img**, **uImageDTS4138** and **dts4138app.img** image.  
2. step: After reboot update **dts4138v2cfg.img** (save configuration before this update)  
See also Bx-800870.06 or higher: chapter 7  

### Added
- Additional SINEC features (only DTS 4138S)
- Added SNMP parameter: order number

### Changed
- Update ftpd pure-ftp 1.0.49
- Update sftp
- Update busybox 1.31.1
- Update ntp 4.2.8p14
- Stop NTP backup when no more NTP server is available.

### Security
- Root user login deactivated

## [05140219.010001.020107 / 25022019] 2019-05-10
### Update instructions
Update is recommended for users of SNMP or SSH  
- First step: Update **rootfsDTS4138.img**, **uImageDTS4138** and **dts4138app.img** image.  
- After reboot update **dts4138cfg.img** (save configuration before this update)   
See also Bx-800870.06 or higher: chapter 7  

### Changed
- Update dropbear (SSH) 2018.76
- Update ntp 4.2.8p12
- Update snmp net-snmp 5.8
- Update openssl 1.1.1a

### Fixed
- Bugfix: SNMP IPv6, network slave clock IPv6

### Security
- Features: SNMP V1 and V2c deselectable

## [04040612.010000.010006 / 28032018] 2018-08-24
### Update instructions
An update is recommended for customers who are using NTP from or to the Internet.

### Added
- Added SIMATIC mode

### Security
- Added accessibility control for NTP control packet (NTPQ)

## [03040612.010000.010005 / 20022015] 2015-02-15
### Update instructions
An update is not needed or recommended for customers. (No functional improvement).   
New devices will have the latest u-boot version.

### Changed
- New version of u-boot 2013.07 to be compatible with latest version of flash on processor module.
  This version of the bootloader is compatible with all versions of used flash. There’s no change in
  functionality of the DTS 4138.timeserver.

## [03040612.010000.010005 / 21102013] 2013-10-28
### Update instructions
If previous version was not equal or newer than 30102012, then update has to be done in 2 steps:
1. step: dts4138app.img and dtscheck.md5
2. step: dts4138cfg.img, uImageDTS4138 and dtscheck.md5  

See also Bx-800870.00 or higher: chapter 7

### Fixed
- SINEC fixed (link reconnect, link lost)
- Fix slave behavior after switch over (no immediate jump back, even if new master has higher stratum)
- SNMP: remove old header from config file (dtsUser1 cannot be set to noauth)
- Restart IPv6 after link reconnect (neighbor solicitation didn’t restart)
- Allow IPv6 TZ requests (for SCP with IPv6)
- Fix hostname handling when DHCP on (set hostname from DHCP, inform DHCP about hostname)
- Do NTP restart after autokey config.
- Fix auto-update of TZ-files (for SCP)
- Block Ctrl-Z to close menu (do not allow close of the menu with Ctrl-Z)

## [02040612.010000.010004 / 30042013] 2013-04-30
### Update instructions
If previous version was not equal or newer than 30102012, then update has to be done in 2 steps:
1. step: dts4138app.img and dtscheck.md5
2. step: dts4138cfg.img, uImageDTS4138 and dtscheck.md5  

See also Bx-800870.00 or higher: chapter 7

### Fixed
- Fixed menu errors
- Manual renew of DHCP release now possible
- /ram directory limited to 16MB (before an overwrite with system crash->reboot was possible)
- update of time zone files changed

## [01040612.010000.010003 / 12112012] 2012-11-16
### Update instructions
If previous version was not 30102012, then update has to be done in 2 steps:
1. step: dts4138app.img and dtscheck.md5
2. step: dts4138cfg.img, uImageDTS4138 and dtscheck.md5  

See also Bx-800870.00 or higher: chapter 7

### Changed
- Season table version 10

### Fixed
- Fixed menu error (info gateway 2 was wrong)
- Fixed IRIG B output (single repeated telegram could occur very seldom, all 3 to 7 days)
- Update problem without DHCP fixed (dts4138cfg.img)

## [01040612.010000.010002 / 30102012] 2012-11-02
### Update instructions
Update has to be done in 2 steps:
1. step: dts4138app.img and dtscheck.md5
2. step: dts4138cfg.img, uImageDTS4138 and dtscheck.md5

See also Bx-800870.00 or higher: chapter 7

### Fixed
- Fixed update error (dts4138cfg.img)
- Fixed menu errors (typing errors)

## [01040612.010000.010001 / 31082012] 2012-09-26
### Update instructions
See Bx-800870.00 or higher: chapter 7

### Fixed
- Fixed IP config. From USB stick
- Fixed SNMP IPv6
- Fixed day of year in IRIG out
- Fixed remove of 2.IP red. server
- Fixed some small menu issues
- Fixed SNMP sysObjectID

## [00040612.010000.010000 / 11062012] 2012-06-12
### Update instructions
See Bx-800870.00 or higher: chapter 7

### Changed
- First release
